/*
 * Copyright (c) 2000-2005 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * The contents of this file constitute Original Code as defined in and
 * are subject to the Apple Public Source License Version 1.1 (the
 * "License").  You may not use this file except in compliance with the
 * License.  Please obtain a copy of the License at
 * http://www.apple.com/publicsource and read it before using this file.
 * 
 * This Original Code and all software distributed under the License are
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
#ifndef _I386_MACHINE_CPU_H_
#define _I386_MACHINE_CPU_H_

#include <mach/mach_types.h>
#include <mach/boolean.h>
#include <kern/kern_types.h>
#include <pexpert/pexpert.h>
#include <sys/cdefs.h>

__BEGIN_DECLS
void	cpu_machine_init(
	void);

void	cpu_signal_handler(
	x86_saved_state_t *regs);

void	handle_pending_TLB_flushes(
	void);


kern_return_t cpu_register(
        int *slot_nump);
__END_DECLS

static inline void cpu_halt(void)
{
	asm volatile( "wbinvd; cli; hlt" );
}

static inline void cpu_pause(void)
{
	asm volatile( "rep; nop" );
}

#endif /* _I386_MACHINE_CPU_H_ */
